#pragma once

#include "wc3/data_store.hpp"
#include "wc3/observer.hpp"
#include "wc3/tempest_thread.hpp"

CDataStore& operator << (CDataStore& store, const NetTag& tag);

class CPresenceRef: public TRefCnt {
public:
	NetTag net_tag;
};

class CAgentField: public CPresenceRef {};
class Integer: public CAgentField {};
class Float: public CAgentField {};
class SmartPosition: public CAgentField {};

class CAgentFieldMini {};

class IntegerMini: CAgentFieldMini {
public:
	int value;
};

class FloatMini: CAgentFieldMini {
public:

	struct VMT {
		void (__thiscall *set_value)(FloatMini* self, float* value, BOOL a3);
	};

  void* vtable;
  float value;
};

class FloatMiniB: public FloatMini {
public:
	float min_value;
	float max_value;
};


class CAgent: public CObserver {
public:

	struct _VMT: CObserver::_VMT {
		void (__thiscall *method18)(CAgent *self, DWORD UnkTypeId, void* struc);
		uint32_t (__thiscall *get_type_id)(CAgent *self);
		int (__thiscall *method20)(CAgent *self, DWORD a0);
		int (__thiscall *method24)(CAgent *self, void* Container);
		int (__thiscall *method28)(CAgent *self, void* Container);
		int (__thiscall *method2C)(CAgent *self, DWORD a0, DWORD a1);
		int (__thiscall *method30)(CAgent *self, DWORD a0);
		int (__thiscall *method34)(CAgent *self);
		int (__thiscall *save)(CAgent *self, void* stream);
		int (__thiscall *load)(CAgent *self, void* DataStore);
		int (__thiscall *method40)(CAgent *self);
		int (__thiscall *debug_print_fields)(CAgent *self, DWORD a0);
		int (__thiscall *method48)(CAgent *self, DWORD a0);
		int (__thiscall *method4C)(CAgent *self, DWORD a0);
		int (__thiscall *method50)(CAgent *self, DWORD a0, DWORD a1, DWORD a2);
		int (__thiscall *method54)(CAgent *self, DWORD a0, DWORD a1, DWORD a2);
		const char* (__thiscall *get_type_name)(CAgent *self);
		int (__thiscall *destroy_agent)(CAgent *self);
	};

    NetTag _net_tag;
    CObserver _agent_observer;

	bool is_valid();
	uint32_t get_type_id();
};

typedef BOOL (__thiscall* TCAgent_IsValid)(CAgent* self);
extern TCAgent_IsValid CAgent_IsValid;

template<typename T>
class CAgentPtr {

	T* value = nullptr;

	CAgentPtr(T* new_value) {
		*this = new_value;
	}

	~CAgentPtr() {
		*this = nullptr;
	}

	T* operator = (T* new_value) {
		T* old_value = value;

		if (new_value) {
			new_value->references++;
		}

		value = new_value;

		if (old_value) {
			old_value->references--;
			if (!old_value->references) {
				old_value->release();
			}
		}
	}

	T& operator -> () const {
		return *value;
	}

	T& operator * () const {
		return *value;
	}
};
