#pragma once

#include "wc3/class_utils.hpp"
#include "wc3/hashtable.hpp"
#include "wc3/data_allocator.hpp"
#include "wc3/ipse.hpp"

class Generator {
public:
	struct VMT {
		void *(__thiscall *create_instance)(Generator* self);
		void (__thiscall *destroy_instance)(Generator* self, void* instance);
		void (__thiscall *destroy)(Generator* self);
	};

	void* vtable;
};

struct AGILE_TYPE_RELATIONSHIP: TSHashObject<AGILE_TYPE_RELATIONSHIP, HASHKEY_4CC> {
	BOOL is_super;
};

struct AGILE_TYPE_DATA: public InsertVMT, public TSHashObject<AGILE_TYPE_DATA, HASHKEY_4CC> {
	struct VMT {
		void (__thiscall* operator_delete)(AGILE_TYPE_DATA* self);
	};

	TSHashTable<AGILE_TYPE_RELATIONSHIP, HASHKEY_4CC> relationships;
	TSHashTable<> descendants;
	void* some_container;
	Generator *generator;
	int field74;
	int parent_type_id;
	BOOL initialized____;
};

struct CAgentBaseAbs: public CRlAgent {};

class CContainerAllocator: public TInstanceAllocator<CAgentBaseAbs> {
public:
	int a;
	int b;
	int c;
};

struct AGILE_DATA {
	struct VMT {
		void (__thiscall* operator_delete)(AGILE_DATA* self);
	};

	void* vtable;
	int build_num;
	int field08;
	TSHashTable<AGILE_TYPE_DATA, HASHKEY_4CC> type_data_table;
	CContainerAllocator* container_fabric;
	int field38;
	int field3C;
	void* timer_dispatcher_;
	void* timer_dispatcher_l_;
	TSGrowableArray<uint8_t> byte_array;
	TSArray<void*> agent_query;
	int field64;
	int field68;
	float field6C;
	float field70;
	int field74;
	int field78;
	int field7C;
	int field80;
	int field84;
	int field88;

	bool is_subtype(uint32_t type_a, uint32_t type_b);

	static AGILE_DATA* instance();
};

extern AGILE_DATA** pp_agile_data;
