#pragma once

#include "wc3/input_events.hpp"
#include "wc3/gui.hpp"

using Row = TSGrowableArray<CSimpleFrame*>;

class CSimpleGrid: public CSimpleFrame {
public:
	DWORD height;
	DWORD width;
	float field12C;
	float field130;
	float field134;
	float field138;
	float field13C;
	float field140;
	float field144;
	float field148;
	TSGrowableArray<Row> rows;
};

using CAbility = void;

struct CCommandButtonData
{
	enum class VisibleText
	{
		TEXT_AND_HINT = 0,
		TEXT = 1,
		NOTHING = 2,
	};

	static const int ORDERS_COUNT = 2;

	void *vtable;
	uint32_t ability_id;
	uint32_t order_id[ORDERS_COUNT];
	uint32_t order_flags[ORDERS_COUNT];
	uint32_t item_presence[ORDERS_COUNT];
	uint32_t item_birth[ORDERS_COUNT];
	VisibleText visible_text;
	char Caption[96];
	char Hint[256];
	char Text[1024];
	uint32_t gold_cost;
	uint32_t wood_cost;
	uint32_t mana_cost;
	uint32_t food_cost;
	uint32_t x;
	uint32_t y;
	uint32_t total_owners_count;
	uint32_t current_owners_count;
	uint32_t hotkey;
	BOOL cast_in_process;
	BOOL show_always_;
	BOOL selecting_target_;
	DWORD Active_1ok_2notok_;
	DWORD charges_amount;
	BOOL has_charges;
	char icon_path[260];
	DWORD icon_color_mask;
	DWORD color_mask_mode;
	CAbility *ability;
};

typedef int (__thiscall* _TCCommandButtonData_GetOrderIndex)(CCommandButtonData* self, MOUSE_BUTTON_FLAGS for_button);
extern _TCCommandButtonData_GetOrderIndex _CCommandButton_GetOrderIndex;

int get_command_index(const CCommandButtonData& data, MOUSE_BUTTON_FLAGS for_button);

class CSimpleButton: public CSimpleFrame {
public:

	enum class State {
		DISABLED = 0,
		NORMAL = 1,
		PUSHED = 2,
	};

	struct VMT: CSimpleFrame::_VMT {
		BOOL (__thiscall* click)(CSimpleButton* self, MOUSE_BUTTON_FLAGS mouse_button);
		int (__thiscall* set_state)(CSimpleButton* self, State state, BOOL clickable);
	};

	CObserver *mouse_click_handler;
	DWORD field128;
	DWORD field12C;
	DWORD field130;
	DWORD field134;
	State state;
	DWORD field13C;
	DWORD field140;
	DWORD field144;
	DWORD field148;
	DWORD field14C;
	float field150_type____;
	float field154;
	DWORD field158;
	DWORD field15C;
	DWORD field160;
	DWORD field164;

	void click(MOUSE_BUTTON_FLAGS mouse_button);
};

class CShrinkingButton: public CSimpleButton {};

class CCommandButton: public CShrinkingButton {
public:
	float field168;
	float field16C;
	float field170;
	float field174;
	float field178;
	float field17C;
	float field180;
	float field184;
	DWORD field188;
	BOOL command_data_owned;
	CCommandButtonData *command_data;
	DWORD field194;
	DWORD field198;
	DWORD field19C;
	DWORD field1A0;
	float field1A4;
	DWORD field1A8;
	DWORD field1AC;
	DWORD field1B0;
	BOOL DontShowDescription;
};

class CCommandBar: public CSimpleGrid {
public:
	struct SubMenuStackItem: public LinkedNode<SubMenuStackItem> {
		DWORD order_id;
	};

	void* replay_panel;
	TSHashTable<> qcode_to_commandreg_table;
	TSHashTable<> dcode_to_ordertype_table;
	DWORD field1B0;
	TSLinkedList<SubMenuStackItem> submenu_items;

	CCommandButton* get_button(int x, int y);
	void update();
	void add_command(CCommandButtonData& data);
	bool close_submenu();
};

typedef void (__thiscall* TCCommandBar_AddCommand)(CCommandBar* self, CCommandButtonData* data);
extern TCCommandBar_AddCommand CCommandBar_AddCommand;
typedef void (__thiscall* TCCommandBar_Update)(CCommandBar* self);
extern TCCommandBar_Update CCommandBar_Update;
