#pragma once

#include <cstdint>
#include <map>

enum class GameVersion {
	unknown,
	v1_26a,
	v1_27a,
};

using Offsets = std::map<GameVersion, uintptr_t>;

const char* get_game_version_name(GameVersion version);
uintptr_t get_offset(const char* name, GameVersion version, const Offsets& offsets);
uintptr_t get_offset(const char* name, const Offsets& offsets);
GameVersion get_game_version();
uintptr_t get_game_base();
