#pragma once

#include "wc3/array.hpp"
#include "wc3/hashtable.hpp"
#include "wc3/observer.hpp"
#include "wc3/agent.hpp"
#include "wc3/timers.hpp"

using AgentHandle = int;

const int FIRST_JASS_HANDLE = 0x100000;

struct Handle2AgentReg {
	unsigned int references;
	CAgent *agent;
	BOOL auto_destroy;
};

class CGameState {
public:
	int field24;
	Float Floats[1];
	int field38;
	Integer Integers[2];
	Float Float5C;
	int field6C;
	int field70;
	int field74;
	int field78;
	int field7C;
	Integer Integer80;
	int EventDataArraysCount;
	TSGrowableArray<int> EventDataStacks[15];
	TSGrowableArray<int> free_handles;
	TSGrowableArray<Handle2AgentReg> handles;
	TSHashTable<> handle_to_agent_table;
	TSHashTable<> HashTable_Func2AgentReg;
	TSHashTable<> HashTable_Filter2AgentReg;
	TSHashTable<> HashTable_GameVarEventRegToSTRI;
	CEvent GameVarChangedEvent;
	int field254;
	TSHashTable<> HastTable_HERONAMESUSED;
	CAgentTimer UpdateFogTimer_;
	CAgentTimer AgentTimer294;
	CAgentTimer AgentTimer2A8;
	NetTag kQuestManager;
	int field2C4;
	int AggregatedTextTagManager;
	int field2CC;
	int field2D0;
	int field2D4;
	int field2D8;
	int field2DC;
	int field2E0;
	int field2E4;
	int field2E8;
	int field2EC;
	int field2F0;
	int field2F4;
	int field2F8;
	int field2FC;
	int field300;
	int field304;
	int field308;
	int field30C;
	int field310;
	int field314;
	int field318;
	int field31C;
	int field320;
	int field324;
	int field328;
	int field32C;
	int field330;
	int field334;
	int field338;
	int field33C;
	int field340;
	int field344;
	int field348;
	int field34C;

	void increment_handle_references(AgentHandle handle);
	void decrement_handle_references(AgentHandle handle);
	void release_handle(AgentHandle handle);
};

typedef void (__thiscall* TCGameState_ReleaseHandle)(CGameState* self, AgentHandle handle);
typedef AgentHandle (__thiscall *TCGameState_GetAgentHandle)(CGameState* self, CAgent* agent, BOOL auto_free);
typedef void (__thiscall* TCGameState_DecrementHandleReferences)(CGameState* self, DWORD handle);

extern TCGameState_GetAgentHandle _CGameState_GetAgentHandle;
extern TCGameState_DecrementHandleReferences _CGameState_DecrementHandleReferences;
extern TCGameState_ReleaseHandle _CGameState_ReleaseHandle;

int handle_to_index(AgentHandle handle);
