#pragma once

#include "wc3/hashtable.hpp"
#include "wc3/observer.hpp"
#include "wc3/agent.hpp"
#include "wc3/selectable.hpp"
#include "wc3/item.hpp"
#include "wc3/multiboard.hpp"
#include "wc3/gui.hpp"
#include "wc3/timers.hpp"
#include "wc3/world_frame.hpp"
#include "wc3/command_bar.hpp"

class CInputMode: public CObserver {
public:
	struct _VMT: CObserver::_VMT {
		int (__thiscall *handles_input_)(CInputMode* self);
		int (__thiscall *method1C)(CInputMode* self);
		int (__thiscall *method20)(CInputMode* self);
		int (__thiscall *method24)(CInputMode* self);
		int (__thiscall *method28)(CInputMode* self);
	};
};

class CSelectMode: public CInputMode {
public:
	DWORD field0C;
	float field10;
	CSelectable *selectable;
	CEventTimer timer;

	static _VMT* VMT;

	BOOL push_command(int ability_id, int order_id, int order_flags, CItem* used_item, CItem* dragged_item, BOOL subgroup_order);
};

typedef BOOL (__thiscall* push_command_func_t)(CSelectMode* self, int ability_id, int order_id, int order_flags, CItem* used_item, CItem* dragged_item, BOOL subgroup_order);
extern push_command_func_t _CSelectMode_push_command;

class CTargetMode: public CInputMode {
public:
	DWORD AbilityId;
	DWORD OrderId;
	DWORD Flags;
	NetTag ItemKeys;
	NetTag DraggingItem;
	NetTag CasterKeys;
	CSelectable *Target;
};

using CChatMode = void;

struct InventorySlot {
	DWORD item_type_id;
	CCommandButton *button;
};

using CInventorySlots = TSGrowableArray<InventorySlot>;

class CInventoryBar: public CSimpleFrame {
public:

	struct _VMT: CSimpleFrame::_VMT {
		void (__thiscall* set_unit)(CInventoryBar* self, CUnit *unit);
		void (__thiscall* update)(CInventoryBar* self);
		void (__thiscall* reset)(CInventoryBar* self);
	};

	CUnit *field124;
	CInventorySlots slots;
	DWORD field138;
	DWORD zero_if_unit_changed;
	DWORD field140;
	DWORD field144;

	void update();
};

class CInfoBar: public CSimpleFrame {
public:
	DWORD field124;
	DWORD field128;
	DWORD field12C;
	DWORD SimpleInfoPanelUnitDetail;
	DWORD SimpleInfoPanelBuildingDetail;
	DWORD SimpleInfoPanelCargoDetail;
	DWORD InfoPanelGroup;
	DWORD SimpleInfoPanelItemDetail;
	DWORD SimpleInfoPanelDestructableDetail;
	CInventoryBar* inventory_bar;
	void* field14C;
	void* InventoryLabel;
};

using HMODEL = void;

class CModelFrame: public CFrame {
public:

	struct _VMT : CFrame::_VMT {
		void (__thiscall* methodE4)(CModelFrame* self);
		void (__thiscall* methodE8)(CModelFrame* self, void* handle_object);
		void (__thiscall* methodEC)(CModelFrame* self, const char* path, void* a3);
		void (__thiscall* clear_models)(CModelFrame* self);
		HMODEL* (__thiscall* get_first_model)(CModelFrame* self);
	};


	TSArray<HMODEL*> models;
};

using CTexture = void;

class CBackdropFrame: CModelFrame {
public:
	DWORD field174;
	CTexture *texture;
	CTexture *border_texture;
	DWORD field180;
	DWORD field184;
	DWORD field188;
	DWORD field18C;
	DWORD field190;
	DWORD field194;
	DWORD field198;
	DWORD field19C;
	DWORD field1A0;
	DWORD field1A4;
	DWORD field1A8;
	DWORD field1AC;
	DWORD field1B0;
	DWORD path_flags_;
	float field1B8;
	float field1BC;
	DWORD field1C0;
	DWORD field1C4;
	float field1C8;
	float field1CC;
	float field1D0;
	float field1D4;
	DWORD field1D8;
};

using CTextFrame = void;

class CChatEditBar: public CBackdropFrame {
public:
	BOOL opened;
	DWORD chat_edit_box;
	CTextFrame *text_frame;
	DWORD chat_mode;
};

class CGameUI: public CScreenFrame {
public:
	DWORD _interface_state_;
	TSHashTable<> _font_cache;
	DWORD _user_control_enabled;
	DWORD _user_ui_enabled;
	CInputMode *_current_input_mode;
	TSGrowableArray<CInputMode*> _input_mode_stack;
	DWORD _tooltip;
	DWORD _uber_tooltip;
	DWORD _show_descriptions;
	DWORD _autosave_replay;
	DWORD _health_bars;
	DWORD _show_minimap_signals;
	DWORD field1E0;
	DWORD field1E4;
	DWORD field1E8;
	DWORD field1EC;
	DWORD field1F0;
	DWORD field1F4;
	DWORD field1F8;
	DWORD field1FC;
	DWORD field200;
	DWORD field204;
	DWORD field208;
	DWORD field20C;
	CTargetMode* _target_mode;
	CSelectMode* _select_mode;
	void* _drag_select_mode;
	void* _drag_scroll_mode;
	void* _build_mode;
	void* _signal_mode;
	void* _esc_menu;
	DWORD field22C;
	void* _suspend_indicator;
	void* _unresponsive_indicator;
	void* _alliance_mode;
	CChatMode *_chat_mode;
	void* _quest_mode;
	void* _script_dialog_mode;
	DWORD field248;
	void* _selection_manager;
	void* _drag_scroll_manager;
	CCameraWar3* _camera;
	DWORD script_paused__;
	DWORD field25C;
	DWORD disallow_unpause_;
	DWORD field264;
	DWORD field268;
	DWORD _unit_ui_dirty;
	DWORD field270;
	DWORD _selection_dirty;
	DWORD _infobar_dirty;
	DWORD _commandbar_dirty;
	DWORD _herobar_dirty;
	DWORD flags284_;
	DWORD field288;
	DWORD _force_cinematic_subtitles;
	DWORD _drag_select_enabled;
	DWORD _drag_select_ui_enabled;
	DWORD _preselect_enabled;
	DWORD _preselect_ui_enabled;
	DWORD _selection_enabled;
	DWORD _selection_ui_enabled;
	CFadeTimer _fade_timer_1;
	CFadeTimer _fade_timer_2;
	CFadeTimer _fade_timer_3;
	DWORD _simple_fade_timer;
	TSArray<CAgentTimer> _agent_timers;
	CAgentTimer _agent_timer;
	DWORD field398;
	DWORD field39C;
	DWORD field3A0;
	DWORD field3A4;
	DWORD field3A8;
	CMultiboard* multiboard;
	DWORD field3B0;
	DWORD field3B4;
	CSelectable *field3B8;
	CWorldFrameWar3 *_world_frame;
	DWORD _minimap;
	CInfoBar* _info_bar;
	CCommandBar* _command_bar;
	DWORD _resource_bar_frame;
	DWORD _upper_button_bar_frame;
	DWORD field3D4;
	DWORD SimpleButton3D8;
	DWORD _hero_bar;
	DWORD _peon_bar;
	DWORD _world_frame_message;
	CSimpleMessageFrame* _world_frame_unit_message;
	CSimpleMessageFrame* _world_frame_chat_message;
	DWORD _world_frame_top_message;
	DWORD _portrait_button;
	DWORD _time_of_day_indicator;
	CChatEditBar* _chat_edit_bar;
	DWORD _cinematic_panel;
	DWORD field404;
	DWORD field408;
	DWORD field40C;
	DWORD field410;
	DWORD field414;
	DWORD field418;
	DWORD field41C;
	DWORD _simple_console;
	CFrame *frame424;
	DWORD InfoPanel_;
	DWORD _hotkey_quick_save;
	DWORD _hotkey_quick_load;
	DWORD _hotkey_quick_help;
	DWORD _hotkey_quick_options;
	DWORD _hotkey_quick_quit;
	DWORD _hotkey_minimap_signal;
	DWORD _hotkey_minimap_terrain;
	DWORD _hotkey_minimap_colors;
	DWORD _hotkey_minimap_creeps;
	DWORD _hotkey_formation_toggle;

	static CGameUI* instance();

	void set_input_mode(CInputMode& mode);
	void close_current_input_mode();
};

typedef void (__thiscall* TCGameUI_CloseCurrentInputMode)(CGameUI* self);
typedef void (__thiscall* TCGameUI_SetInputMode)(CGameUI* self, CInputMode* mode, BOOL push_old);
extern TCGameUI_CloseCurrentInputMode _CGameUI_CloseCurrentInputMode;
extern TCGameUI_SetInputMode _CGameUI_SetInputMode;
extern CGameUI** p_global_with_game_ui_instance;
