#pragma once

#include <cstddef>
#include <cstdint>
#include "wc3/array.hpp"
#include "wc3/string.hpp"
#include "wc3/synchronous_data.hpp"
#include "wc3/player_war3.hpp"
#include "wc3/game_state.hpp"

// temporal stubs
typedef void CTriggerExecution;
typedef void CGameCacheManager;

struct SlotStruct2C
{
	float StartLocX;
	int field04;
	int field08;
	int field0C;
	int field10;
	int field14;
	int field18;
	int field1C;
	int field20;
	int field24;
	int field28;
};

class CGameWar3: public CSynchronousData
{
public:
	struct _VMT: CSynchronousData::VMT {
		void (__thiscall* operator_delete)(CGameWar3* self, bool free_memory);
		void (__thiscall* debug_print2)(CGameWar3* self, char* buffer, size_t size);
		CDataStore* (__thiscall* save)(CGameWar3* self, CDataStore* store);
		CDataStore* (__thiscall* load)(CGameWar3* self, CDataStore* store);
	};

	int main_jass_script;
	int main_jass_thread;
	TSGrowableArray<CTriggerExecution*> executions;
	CGameState *game_state;
	void* GameIdMaps__OrdersMap_;
	uint32_t build_number;
	PlayerNumber local_player_id;
	PlayerNumber replay_player_id;
	int field2C;
	void* MapSetupWar3;
	void* FogOfWarMap;
	int jstr_field38;
	int field3C;
	int field40;
	int field44;
	int players_count;
	int field4C;
	int field50;
	int field54;
	CPlayerWar3 *players[16];
	int field98;
	int field9C;
	int teams_fieldA0;
	int fieldA4;
	int fieldA8;
	SlotStruct2C slots_info[12];
	int field2BC;
	int field2C0;
	int field2C4;
	int field2C8;
	int field2CC;
	int field2D0;
	int field2D4;
	int field2D8;
	int field2DC;
	int field2E0;
	int field2E4;
	int field2E8;
	int field2EC;
	RCString map_name;
	int jstr_field2FC;
	int field300;
	int field304;
	int jstr_field308;
	int field30C;
	int field310;
	int jstr_field314;
	int field318;
	int field31C;
	int field320;
	BOOL do_score_screen;
	int field328;
	int field32C;
	int field330;
	int field334;
	int field338;
	int word_field33C;
	int field340;
	int field344;
	int field348;
	int field34C;
	int field350;
	int field354;
	int field358;
	int field35C;
	int field360;
	int field364;
	int field368;
	int field36C;
	int field370;
	int field374;
	int field378;
	int field37C;
	int field380;
	int field384;
	int field388;
	int field38C;
	int field390;
	int field394;
	int field398;
	int field39C;
	int field3A0;
	int field3A4;
	int field3A8;
	int field3AC;
	int field3B0;
	int field3B4;
	int field3B8;
	int field3BC;
	int TerrainDarkMasked;
	int field3C4;
	BOOL is_replay;
	int jstr_field3CC;
	int field3D0;
	int field3D4;
	int field3D8;
	int field3DC;
	int field3E0;
	int field3E4;
	int field3E8;
	int TriggerStrings;
	int field3F0;
	int field3F4;
	int field3F8;
	int field3FC;
	CGameCacheManager *game_cache_manager;
	void* hash_table_manager;

	CPlayerWar3* local_player() const;

	static CGameWar3* instance();
};

extern CGameWar3** _p_global_variable_with_gamewar3_instance;
