#pragma once

#include "wc3/geometry.hpp"
#include "wc3/linkedlist.hpp"
#include "wc3/hashtable.hpp"
#include "wc3/observer.hpp"
#include "wc3/input_events.hpp"

class CLayoutFrame;

class CFramePoint {
public:
	struct _VMT {
		int (__thiscall *operator_delete)(CFramePoint *self, bool free_memory);
		int (__thiscall *method04)(CFramePoint *self);
		double (__thiscall *get_y_)(CFramePoint *self, float);
		CLayoutFrame *(__thiscall *GetLayoutFrame)(CFramePoint *self);
	};

	void* _vtable;
};

class CFramePointAbsolute: CFramePoint {
public:
	float x_;
	float y_;
};

class CFramePointRelative: CFramePoint {
public:
	CLayoutFrame *layout_frame;
	DWORD index_;
	float offset_x_;
	float offset_y_;
};

class FRAMENODE {
public:

	struct _VMT {
		void (__thiscall *operator_delete)(FRAMENODE* self, bool free_memory);
	};

	void* vtable;
	LinkedNode<FRAMENODE> node;
	CLayoutFrame* value;
	DWORD flags_;
};


class CLayoutFrame {
public:

	struct _VMT {
		int (__thiscall *rect_changed____)(CLayoutFrame *self, RectWar3 *rect___);
		RectWar3 *(__thiscall *recalc_rect____)(CLayoutFrame *self);
		int (__thiscall *method08)(CLayoutFrame *self);
		int (__thiscall *set_rect_____)(CLayoutFrame *self);
		RectWar3 *(__thiscall *get_rect_____)(CLayoutFrame *self, RectWar3 *rect__);
		void (__thiscall *SetField60)(CLayoutFrame *self, float value);
		int (__thiscall *method18)(CLayoutFrame *self);
		int (__thiscall *method1C)(CLayoutFrame *self);
		int (__thiscall *method20)(CLayoutFrame *self);
	};

	void* _vtable;
	int count;
	CFramePoint *FramePoints[9];
	int flags;
	LinkedNode<CLayoutFrame> Node;
	TSLinkedList<FRAMENODE> childs_;
	float rect___[4];
	BOOL enabled_______;
	float width__;
	float height_;
	float maybe_something_with_y_or_scale____;
	BOOL is_main_layout_______;
};

class CSimpleFrame;

struct SIMPLEFRAMENODE: LinkedNode<SIMPLEFRAMENODE> {
	CSimpleFrame *content;
};

class CSimpleTop;

class CSimpleFrame: public CLayoutFrame {
public:

	struct _VMT: CLayoutFrame::_VMT {
		int (__thiscall *method24)(CSimpleFrame* self);
		int (__thiscall *contains_point)(CSimpleFrame* self, Vector2f *point);
		int (__thiscall *OnShown__)(CSimpleFrame* self);
		int (__thiscall *OnHide___)(CSimpleFrame* self);
		int (__thiscall *method34)(CSimpleFrame* self);
		int (__thiscall *can_handle_mouse_event_)(CSimpleFrame* self, CMouseEvent *event_);
		int (__thiscall *method3C)(CSimpleFrame* self);
		int (__thiscall *method40)(CSimpleFrame* self);
		int (__thiscall *method44)(CSimpleFrame* self);
		int (__thiscall *method48)(CSimpleFrame* self);
		int (__thiscall *method4C)(CSimpleFrame* self);
		int (__thiscall *method50)(CSimpleFrame* self);
		int (__thiscall *method54)(CSimpleFrame* self);
		int (__thiscall *method58)(CSimpleFrame* self);
		int (__thiscall *method5C)(CSimpleFrame* self);
		int (__thiscall *method60)(CSimpleFrame* self);
		int (__thiscall *Hide)(CSimpleFrame* self);
		int (__thiscall *Show)(CSimpleFrame* self);
	};

	CSimpleTop *last_created_CSimpleTop__;
	CSimpleFrame *parent____;
	CSimpleFrame *maybe_frame___;
	DWORD field74;
	DWORD field78;
	char *simple_context_key_;
	DWORD simple_context_hash_object_key_;
	DWORD zindex_____;
	DWORD field88;
	DWORD layers_mask___;
	DWORD can_be_shown___;
	BOOL visible;
	RectWar3 rect;
	float fieldA8;
	float fieldAC;
	float fieldB0;
	float fieldB4;
	DWORD render_bools_4___;
	DWORD fieldBC;
	DWORD fieldC0;
	DWORD fieldC4;
	DWORD fieldC8;
	DWORD fieldCC;
	TSLinkedList<void*> listD0;
	TSLinkedList<void*> listsDC[5];
	TSLinkedList<SIMPLEFRAMENODE> childs_;
};

class CSimpleMessageFrame: public CSimpleFrame {
public:
	struct _VMT: CSimpleFrame::_VMT {
		void (__thiscall *print)(CSimpleMessageFrame* self, const char* Message, DWORD* pColor, float Duration, BOOL Permanent);
	};

	DWORD lines_count_;
	DWORD field128;
	char *font_path;
	float font_height;
	DWORD field134_forfont;
	DWORD max_line_length_;
	DWORD field13C;
	DWORD default_text_color_;
	float floats144[2];
	float field14C;
	float field150;
	float field154;
	float field158;
	float field15C;
	float field160;
	float field164;
	float field168;
	float field16C;
	DWORD field170;
	TSGrowableArray<void*> messages_;
	DWORD field184;
	DWORD field188;
	DWORD field18C;
	DWORD field190;

	void print(const char* message, DWORD color = 0xFFFFFFFF, float duration = 10.0, bool permanent = false);
};

class CFrame;

class LayerNode {
public:

	struct _VMT {
		void (__thiscall *operator_delete)(LayerNode* self, bool free_memory);
	};

	void* vtable;
	LinkedNode<LayerNode> Node;
	CFrame* value;
};

class CLayer: public CObserver {
public:

	struct _VMT: CObserver::_VMT {
		int (__thiscall *method18)(CLayer *self);
		int (__thiscall *method1C)(CLayer *self);
		int (__thiscall *method20)(CLayer *self);
		int (__thiscall *method24)(CLayer *self);
		int (__thiscall *method28)(CLayer *self);
		int (__thiscall *method2C)(CLayer *self);
		int (__thiscall *method30)(CLayer *self);
		int (__thiscall *method34)(CLayer *self);
		int (__thiscall *on_mouse_down)(CLayer *self, CMouseEvent* event);
		int (__thiscall *method3C)(CLayer *self);
		int (__thiscall *method40)(CLayer *self);
		int (__thiscall *method44)(CLayer *self);
		int (__thiscall *method48)(CLayer *self);
		int (__thiscall *method4C)(CLayer *self);
		int (__thiscall *on_char_event__)(CLayer *self);
		int (__thiscall *on_key_down__)(CLayer *self);
		int (__thiscall *method58)(CLayer *self);
		int (__thiscall *method5C)(CLayer *self);
		int (__thiscall *method60)(CLayer *self);
		int (__thiscall *method64)(CLayer *self);
		int (__thiscall *method68)(CLayer *self);
		int (__thiscall *method6C)(CLayer *self);
		int (__thiscall *on_add_to_interface_frame_gvar)(CLayer *self);
		int (__thiscall *on_remove_from_interface_frame_gvar)(CLayer *self);
		int (__thiscall *method78)(CLayer *self);
		int (__thiscall *method7C)(CLayer *self);
		int (__thiscall *method80)(CLayer *self);
		int (__thiscall *method84)(CLayer *self);
		int (__thiscall *method88)(CLayer *self);
		int (__thiscall *method8C)(CLayer *self);
		int (__thiscall *method90)(CLayer *self);
		int (__thiscall *method94)(CLayer *self);
		int (__thiscall *method98)(CLayer *self);
		int (__thiscall *method9C)(CLayer *self);
		int (__thiscall *methodA0)(CLayer *self);
		int (__thiscall *on_alpha_updated_)(CLayer *self);
		int (__thiscall *methodA8)(CLayer *self);
		int (__thiscall *methodAC)(CLayer *self);
		int (__thiscall *methodB0)(CLayer *self);
		int (__thiscall *methodB4)(CLayer *self);
		int (__thiscall *methodB8)(CLayer *self);
		int (__thiscall *methodBC)(CLayer *self);
		int (__thiscall *methodC0)(CLayer *self);
		int (__thiscall *methodC4)(CLayer *self);
		int (__thiscall *methodC8)(CLayer *self);
		int (__thiscall *methodCC)(CLayer *self);
		int (__thiscall *methodD0)(CLayer *self);
		int (__thiscall *methodD4)(CLayer *self);
		int (__thiscall *methodD8)(CLayer *self);
	};

	DWORD flags0C_;
	DWORD flags10_;
	TSLinkedList<LayerNode> childs;
	CLayer *parent;
	DWORD constructor_a3;
	DWORD field28;
	DWORD CursorSprite;
	DWORD field30;
	float float34;
	DWORD field38;
	DWORD field3C;
	DWORD field40;
	CLayer *field44_this;
	DWORD field48;
	DWORD field4C;
	DWORD field50;
	DWORD field54;
	DWORD field58;
	DWORD field5C;
	DWORD field60;
	DWORD field64;
	CLayer *field68_this;
	float float6C;
	float float70;
	TSLinkedList<void*> list74;
	TSHashTable<> ShortcutsTable_;
	DWORD constructor_a4;
	DWORD color_;
	DWORD flags;
};

class CFrame: public CLayer, public CLayoutFrame {
public:

	struct _VMT: CLayer::_VMT {
		int (__thiscall *methodDC)(CFrame *self);
		int (__thiscall *methodE0)(CFrame *self);
	};

	DWORD field11C;
	DWORD field120;
	DWORD field124;
	DWORD field128;
	float field12C;
	float field130;
	float field134;
	float field138;
	float field13C;
	DWORD field140;
	TSLinkedList<void*> list144;
	TSLinkedList<void*> list150;
	DWORD field15C;
	DWORD field160;
	DWORD field164;
};

struct FramePriorities {
	TSGrowableArray<void*> priorities;
	size_t length;
	size_t capacity;
};

class CRenderBatch {
public:
	struct _VMT {
		void (__thiscall *operator_delete)(CRenderBatch* self, bool free_memory);
	};

	void* vtable;
	DWORD field04;
	DWORD field08;
	DWORD field0C;
	DWORD field10;
	DWORD simple_batched_texture;
	DWORD field18;
};

class CSimpleTop: public CFrame {
public:
	BOOL mouse_event_object_initialized;
	CSimpleFrame *hovered_frame;
	CSimpleFrame *field170;
	TSLinkedList<SIMPLEFRAMENODE> frames;
	TSLinkedList<SIMPLEFRAMENODE> simple_frames;
	TSLinkedList<SIMPLEFRAMENODE> simple_frame_layers_[10];
	DWORD some_bytes[10][5];
	CRenderBatch render_batch_list[50];
	DWORD field844;
	DWORD field848;
	DWORD field84C;
	DWORD field850;
	DWORD field854;
	DWORD field858;
	DWORD field85C;
	DWORD field860;
	DWORD field864;
	DWORD field868;
	DWORD field86C;
	DWORD AllLayerEnabled___;
	FramePriorities priorities[4];
	EVENT_DATA_MOUSE mouse_event_data;

	static CSimpleTop* instance();
};

extern CSimpleTop** CSimpleTop_Instance;

class CScreenFrame: public CFrame {
public:
	DWORD field168;
	DWORD field16C;
	TRefCnt* objects170[4];
};

CObserver* get_layer_input_observer();
