#pragma once

#include "wc3/array.hpp"
#include "wc3/linkedlist.hpp"
#include "wc3/data_recycler.hpp"
#include "wc3/data_store.hpp"
#include "wc3/synchronous_data.hpp"
#include "wc3/net_commands.hpp"

class NetGameStore: public CDataStoreChunked {
public:
	DWORD field70;
	DWORD field74;
	DWORD field78;
	DWORD field7C;
	DWORD field80;
	DWORD field84;
	DWORD field88;
	DWORD field8C;
	DWORD field90;
	DWORD field94;
	DWORD field98;
	DWORD field9C;
	DWORD fieldA0;
	DWORD fieldA4;
	DWORD fieldA8;
	DWORD fieldAC;
	DWORD fieldB0;
	DWORD fieldB4;
	DWORD fieldB8;
	DWORD fieldBC;
	DWORD fieldC0;
	DWORD fieldC4;
	DWORD fieldC8;
	DWORD fieldCC;
	DWORD fieldD0;
	DWORD fieldD4;
	DWORD fieldD8;
	DWORD fieldDC;
	DWORD fieldE0;
	DWORD fieldE4;
	DWORD fieldE8;
	CDataRecycler recycler2;
	DWORD AsyncFileHandle_;
	char file_path[260];
	DWORD field20C;
	DWORD field210;
	DWORD field214;
	DWORD field218;
	DWORD field21C;
	DWORD field220;
	DWORD field224;
	DWORD field228;
	DWORD field22C;
	DWORD field230;
	DWORD ProductCode;
	DWORD VersionNumber;
	DWORD BuildNumber;
	DWORD field240;
	char loaded_file_path[260];
	DWORD field348;
};

class CTurnStore: public CDataStoreCache<1460> {
public:
	void flush();
};

class CNetData: public CSynchronousData {
public:

	class CNetEvent: public LinkedNode<CNetEvent> {
	public:
		void* buffer;
		size_t size;
		size_t capacity;
		uint8_t id;
		uint8_t unk;

		CNetEvent(void* buffer, size_t size, size_t capacity, uint8_t id, uint8_t unk);
	};

	enum class NetEventType {
		INCOMING_ACTIONS2 = 0x1E,
		INCOMING_ACTIONS = 0x1F,
		HZ_24h = 0x24,
	};

	class CNetEventQueue {
	public:

		enum class CounterType {
			Other = 0,
			Game = 1,
		};

		const CounterType session_to_counter[3] = {
			CounterType::Game,
			CounterType::Other,
			CounterType::Other
		};

		TSLinkedList<CNetEvent> events;
		DWORD net_event_counters[2][255];

		void add(CNetEvent* event);
	};

	int SessionsCount_;
	CNetSession sessions[2];
	CNetSession::Type current_session_type;
	int ReplayState;
	NetGameStore StreamingInStore;
	int VersionId;
	int VersionNumber;
	int BuildNumber;
	int field96C;
	int field970;
	int field974;
	int field978;
	int field97C;
	int field980;
	int field984;
	int field988;
	int field98C;
	int field990;
	int field994;
	int field998;
	int field99C;
	int field9A0;
	int field9A4;
	int field9A8;
	int field9AC;
	int field9B0;
	int field9B4;
	int field9B8;
	int field9BC;
	int field9C0;
	int field9C4;
	int field9C8;
	int field9CC;
	int field9D0;
	int field9D4;
	int field9D8;
	int field9DC;
	int field9E0;
	int field9E4;
	int field9E8;
	int field9EC;
	int field9F0;
	int field9F4;
	int field9F8;
	int field9FC;
	int fieldA00;
	int fieldA04;
	int fieldA08;
	int fieldA0C;
	int fieldA10;
	int fieldA14;
	int fieldA18;
	int fieldA1C;
	int fieldA20;
	int ReplayRecord19;
	int fieldA28;
	int fieldA2C;
	int fieldA30;
	int fieldA34;
	int fieldA38;
	int fieldA3C;
	int fieldA40;
	int fieldA44;
	int fieldA48;
	int fieldA4C;
	int fieldA50;
	int fieldA54;
	int fieldA58;
	int fieldA5C;
	int fieldA60;
	int fieldA64;
	int fieldA68;
	int fieldA6C;
	int fieldA70;
	int fieldA74;
	int fieldA78;
	int fieldA7C;
	int fieldA80;
	int fieldA84;
	int fieldA88;
	int fieldA8C;
	int fieldA90;
	int fieldA94;
	int fieldA98;
	int fieldA9C;
	int fieldAA0;
	int fieldAA4;
	TSGrowableArray<PLAYERDATA> PlayersData;
	int ReplayDuration;
	int fieldABC;
	int ReplayDuration2;
	int IsReplayMultiplayer_;
	int fieldAC8;
	int fieldACC;
	BOOL ReplayDataDone;
	int fieldAD4;
	int fieldAD8;
	int fieldADC;
	int fieldAE0;
	int fieldAE4;
	int fieldAE8;
	int fieldAEC;
	int fieldAF0;
	int fieldAF4;
	int fieldAF8;
	int fieldAFC;
	int fieldB00;
	int fieldB04;
	int fieldB08;
	int fieldB0C;
	int fieldB10;
	int fieldB14;
	int fieldB18;
	int fieldB1C;
	int fieldB20;
	int fieldB24;
	int fieldB28;
	int fieldB2C;
	int fieldB30;
	int fieldB34;
	int fieldB38;
	int fieldB3C;
	int fieldB40;
	int fieldB44;
	int fieldB48;
	int fieldB4C;
	int fieldB50;
	int fieldB54;
	int fieldB58;
	int fieldB5C;
	int fieldB60;
	int fieldB64;
	int fieldB68;
	int fieldB6C;
	int fieldB70;
	int fieldB74;
	int fieldB78;
	int fieldB7C;
	int fieldB80;
	int fieldB84;
	int fieldB88;
	int fieldB8C;
	int fieldB90;
	int fieldB94;
	int fieldB98;
	int fieldB9C;
	int fieldBA0;
	int fieldBA4;
	int fieldBA8;
	int fieldBAC;
	int fieldBB0;
	int fieldBB4;
	int fieldBB8;
	int fieldBBC;
	int fieldBC0;
	int fieldBC4;
	int fieldBC8;
	int fieldBCC;
	int fieldBD0;
	int fieldBD4;
	int fieldBD8;
	int fieldBDC;
	int fieldBE0;
	int RecordState;
	NetGameStore RecordingStore;
	int fieldF30;
	int fieldF34;
	CNetEventQueue net_event_queue;
	int field173C;
	int Array1744_Length;
	int array1744[255];
	CNetEvent *some_event_;
	BOOL SavingGame;
	CNetCommandSave SaveCommand;
	int GameChecksum;
	int TurnId;
	int emitting_ticks_;
	int GameTickCount;
	BOOL IsNotSingleplayer_;
	CTurnStore turn_store;
	int turn_reserved_bytes;
	int field2248;
	int LastUpdateTime_;
	int field2250;
	int field2254;
	int field2258;
	int enqueued_commands_size;
	int TurnsLatency_;
	int field2264;
	int field2268;
	int field226C;
	int field2270;
	BOOL Debug_;
	void* object2278_vtable;
	int field227C;
	int field2280;
	char *DebugStr;
	int net_provider_id;
	int field228C;
	TInstanceRecycler<CNetEvent> net_event_recycler;
	float normal_speed_;
	float field22B0;
	int ReplaySpeed;
	int ReplaySpeedDivisor;
	int Paused_;
	int ticks_mod250_;
	int LangId;
	char ComputerName[128];
	char SysTimeStr[128];

	void _send_turn_sp();
	void _send_turn();

	bool send_command(CDataStore& store, CNetSession::Type session_type);
};
