#pragma once

#include "wc3/array.hpp"
#include "wc3/hashtable.hpp"
#include "wc3/data_allocator.hpp"
#include "wc3/observer.hpp"

class CCallbackWrapperObserver: public CObserver {
public:
	CCallbackWrapperObserver *next;
	DWORD event_id;
	DWORD callback;
};

struct GameInfo {
	char GameName[32];
	char Password__[16];
	char EncodedString[128];
	int PlayerCount;
	int GameType;
};

struct PLAYERDATA_a {
	BYTE count;
	BYTE buffer[8];
};

struct PLAYERDATA {
	char PlayerName[16];
	PLAYERDATA_a hz;
};

class __attribute__((packed)) CPlayer: TSHashObject<CPlayer, HASHKEY_NONE> {
public:
	BYTE start_loc;
	PLAYERDATA data;
	DWORD field32;
	BYTE Index;
	BYTE field37;
	DWORD pauses_counter_;
	DWORD saves_performed_;
	DWORD finished_saving__;
	DWORD finished_saving_result__;
};

class CPlayers {
public:
	TSHashTable<> table;
	TSGrowableArray<CPlayer*> game_players;
	TSGrowableArray<CPlayer*> lobby_players;
	int Count;

	CPlayer* get(int player_id);
	int get_start_loc_(int player_id);
};

struct SUSPENDPLAYER {
	unsigned char id;
	DWORD lag_start_time;
};

class CNetSession {
public:

	enum class Type {
		Game,
		Replay,
		None
	};

	enum class GameState {
		NONE = 0,
		JOINED = 1,
		FAKED = 2,
		LOADING = 3,
		PLAYING = 4,
		PAUSING = 5,
		PAUSED = 6,
	};

	void* vtable;
	CObserver NetEventCallbackObserver_;
	CObserver Observer10;
	CDataAllocator CallbackObserverAllocator;
	DWORD field30;
	CCallbackWrapperObserver *command_observers[64];
	GameInfo game_info;
	BYTE buffer_field1EC[130];
	GameState state;
	DWORD field274;
	DWORD field278;
	DWORD ProcessedCommandsSize;
	DWORD field280;
	DWORD field284;
	CPlayers players;
	unsigned char local_player_id;
	unsigned char PlayerThatPausedTheGame_;
	DWORD CommandsSizeToProcessBeforeSaveInterrupt_;
	BOOL GameWasPausedForSave_;
	TSArray<SUSPENDPLAYER> suspended_players;
	DWORD field2EC;
	DWORD field2F0;
	DWORD field2F4;
	DWORD field2F8;
	void* game_result;
	DWORD field300;
};

class CNetEventBase: public CEvent {
public:
	CNetSession::Type session;
};
