#pragma once

class TRefCnt {
public:
	void *_vtable;
	unsigned int _references;
public:
	struct _VMT {
		void (__thiscall* free)(TRefCnt* self);
		void (__thiscall* operator_delete)(TRefCnt* self, bool free_memory);
	};

	void free();
	void increment_references();
	void decrement_references();
};

template<typename T>
class TRefCntPtr {
	T* _value;
public:
	TRefCntPtr(T* value) {
		_value = value;
		if (_value) { _value->increment_references(); }
	}

	TRefCntPtr(const TRefCntPtr& other) {
		_value = other._value;
		if (_value) { _value->increment_references(); }
	}

	TRefCntPtr(TRefCntPtr&& other) {
		_value = other._value;
		other._value = nullptr;
	}

	TRefCntPtr& operator = (const TRefCntPtr& other) {
		if (_value) { _value->decrement_references(); }
		_value = other._value;
		if (_value) { _value->increment_references(); }
	}

	TRefCntPtr& operator = (TRefCntPtr&& other) {
		if (_value) { _value->decrement_references(); }
		_value = other._value;
		other._value = nullptr;
	}

	~TRefCntPtr() {
		if (_value) { _value->decrement_references(); }
	}
};
