#pragma once

#include <cstdint>
#include <windef.h>
#include "wc3/class_utils.hpp"
#include "wc3/data_allocator.hpp"

struct NetTag {
	uint32_t presence, birth;
};

class CEntity {
public:
	void* vtable;
};

class CMemBlock: public CEntity {
public:
	struct SomeItem {
		int field00;
		void* memory;
	};

	void* memory;
	size_t total_size_;
	SomeItem* p_extra_memory;
	size_t extra_size;
};

template<typename T>
class CMemBlockT: public CMemBlock {};

template<typename T>
class CDynTable: public CMemBlockT<T> {
public:
	int field14;
	int field18;
	int size;
};

class CPrRgEntry;

class tempest_thread_parent {
public:
	CDynTable<CPrRgEntry> dyntables[2];
	int field40;
	int field44;
	int field48;
	int field4C;
	int field50;
	int field54;
	int field58;
};

template<typename T>
struct CLinkedNode {
	T* previous;
	T* next;
};

class CPresence: public InsertVMT, public CLinkedNode<CPresence> {
public:
	uint32_t ClassId;
	uint32_t TypeId;
};

class CPresenceTagged: public CPresence {
public:
	NetTag self_tag;
};

struct tempest_thread: public tempest_thread_parent {
public:
	CDataAllocator field5C;
	int field70;
	int field74;
	int field78;
	CDataAllocator field7C;
	int field90;
	int field94;
	int field98;
	CDataAllocator field9C;
	int fieldB0;
	int fieldB4;
	int fieldB8;
	CDataAllocator fieldBC;
	int fieldD0;
	int fieldD4;
	int fieldD8;

	CPresenceTagged* get_container(const NetTag& tag);

	static tempest_thread* instance();
};

extern tempest_thread** pp_tempest_thread;
