#pragma once

#include "wc3/array.hpp"
#include "wc3/gamewar3.hpp"

const int TERRAIN_CLICK_EVENT_ID = 0x1A0068;

class CTerrainClickEvent: public CEvent {
public:
	int field10;
	float field14;
	float field18;
	Vector3f point;
	int mouse_button;
};

const int SPRITE_CLICK_EVENT_ID = 0x1A0064;

class CSpriteClickEvent: public CTerrainClickEvent {
public:
	void* AllocatedHandleObjectLeaf_CSpriteUber_;
	CWidget *widget;
};

const int GHOST_SPRITE_CLICK_EVENT_ID = 0x1A0065;

using CGhostImage = CAgent;

class CGhostSpriteClickEvent: public CSpriteClickEvent {
public:
	void* field34;
	CGhostImage* ghost_image;
};

using CCameraWar3 = void;

class CCinematicFilter {
public:

	struct _VMT {
		void (__thiscall *operator_delete)(CCinematicFilter *self, bool free_memory);
	};

	void* vtable;
	DWORD field04;
	DWORD field08;
	DWORD field0C;
	RCString string10;
	DWORD field1C;
	DWORD field20;
	DWORD field24;
	DWORD field28;
	DWORD field2C;
	DWORD field30;
	DWORD field34;
	DWORD field38;
	DWORD field3C;
	DWORD field40;
	DWORD field44;
	DWORD field48;
	DWORD field4C;
	DWORD field50;
	DWORD field54;
	DWORD field58;
	DWORD field5C;
	DWORD field60;
	DWORD field64;
	DWORD field68;
	DWORD field6C;
	DWORD field70;
	DWORD field74;
	DWORD field78;
	DWORD field7C;
	DWORD field80;
	DWORD field84;
	DWORD field88;
	DWORD field8C;
	DWORD field90;
	DWORD field94;
	DWORD field98;
	DWORD field9C;
};

struct CWorldFrameWar3_1C {
	int field00;
	int field04;
	int field08;
	int field0C;
	int field10;
	int field14;
	int field18;
};

class CWorldFrameWar3: public CFrame {
public:
	int field168;
	CWorldFrameWar3_1C *field16C;
	CWorldFrameWar3_1C *field170;
	CWorldFrameWar3_1C *field174;
	CGameWar3 *game;
	int field17C;
	int field180;
	int field184;
	int field188;
	float field18C;
	float field190;
	float field194;
	int field198;
	CCameraWar3 *camera;
	int Minimap;
	int mouse_key_to_detect____;
	int field1A8;
	int field1AC;
	int field1B0;
	int field1B4;
	int field1B8_CursorMode;
	int field1BC;
	int UserControlDisabled;
	int UserControlEnabled;
	RCString string1C8;
	float field1D4;
	float field1D8;
	float field1DC;
	float field1E0;
	int field1E4;
	int field1E8;
	int field1EC;
	int field1F0;
	int field1F4;
	int field1F8;
	int field1FC;
	int field200;
	int field204;
	int field208;
	int field20C;
	int field210;
	int field214;
	int field218;
	int field21C;
	int field220;
	int field224;
	int field228;
	int field22C;
	int field230;
	int field234;
	float field238;
	float field23C;
	int field240;
	CSelectable *object_under_cursor;
	int field248;
	int field24C;
	int field250;
	CCinematicFilter CinematicFilter;
	int field2F4;
	int field2F8;
	int field2FC;
	int field300;
	int field304;
	int field308;
	int field30C;
	Vector3f terrain_cursor_position;
	int field31C;
	int IgnoreClickEvent______;
	int OcclusionEnabled;
	int field328;
	int field32C;
	BOOL bRenderObjects_;
	int hFog;
	int field338;
	int field33C;
	int hLight;
	int field344;
	RCString string348;
	int field354;
	int field358;
	int field35C;
	int field360;
	int field364;
	int field368;
	int field36C;
	int field370_target_indicator_;
	int field374;
	int field378;
	int field37C;
	float field380;
	float field384;
	int field388;
	int CameraPositionChanged_;
	float field390;
	float field394;
	int field398;
	int field39C;
	int field3A0;
	int field3A4;
	int field3A8;
	int field3AC;
	int field3B0;
	int field3B4;
	int field3B8;
	int field3BC;
	int field3C0;
	int field3C4;
	int field3C8;
	int field3CC;
	int field3D0;
	int field3D4;
	int field3D8;
	int field3DC;
	int field3E0;
	int field3E4;
	int field3E8;
	int field3EC;
	int field3F0;
	int field3F4;
	int field3F8;
	int field3FC;
	int field400;
	int field404;
	int field408;
	int field40C;
	int field410;
	int field414;
	int field418;
	int field41C;
	int field420;
	int field424;
	int field428;
	int field42C;
	int field430;
	int field434;
	int field438;
	int field43C;
	int field440;
	int field444;
	int field448;
	int field44C;
	int field450;
	int field454;
	int field458;
	int field45C;
	int field460;
	int field464;
	int field468;
	int field46C;
	int field470;
	int field474;
	int field478;
	int field47C;
	int field480;
	int field484;
	int field488;
	int field48C;
	int field490;
	int field494;
	int field498;
	int field49C;
	int field4A0;
	int field4A4;
	int field4A8;
	int field4AC;
	int field4B0;
	int field4B4;
	int field4B8;
	int field4BC;
	int field4C0;
	int field4C4;
	int field4C8;
	int field4CC;
	int field4D0;
	int field4D4;
	int field4D8;
	int field4DC;
	int field4E0;
	int field4E4;
	int field4E8;
	int field4EC;
	int field4F0;
	int field4F4;
	int field4F8;
	int field4FC;
	int field500;
	int field504;
	int field508;
	int field50C;
	int field510;
	int field514;
	int field518;
	int field51C;
	int field520;
	int field524;
	int field528;
	int field52C;
	int field530;
	int field534;
	int field538;
	int field53C;
	int field540;
	int field544;
	int field548;
	int field54C;
	int field550;
	int field554;
	int field558;
	int field55C;
	int field560;
	int field564;
	int field568;
	int field56C;
	int field570;
	int field574;
	int field578;
	int field57C;
	int field580;
	int field584;
	int field588;
	int field58C;
	int field590_waypoint_indicator_;
	int field594;
	int field598;
	int field59C;
	int field5A0;
	int field5A4;
	int field5A8;
	int field5AC;
	int field5B0;
	int field5B4;
	int field5B8;
	int field5BC;
	int field5C0;
	int field5C4;
	int field5C8;
	int field5CC;
	int field5D0;
	int field5D4;
	int field5D8;
	int field5DC;
	int field5E0;
	int field5E4;
	int field5E8;
	int field5EC;
	int field5F0;
	int field5F4;
	int field5F8;
	int field5FC;
	int CAgentPtr_CUnit_List_field600;
	int field604;
	int field608;
	int field60C;
	int field610;
	int field614;
	int field618;
	int field61C;
	TSGrowableArray<CAgentPtr<CUnit>> CAgentPtr_CUnit_List_field620;
	int CAgentPtr_CSelectable_List_field630;
	int field634;
	int field638;
	int field63C;
	TSGrowableArray<CAgentPtr<CWidget>> WidgetPtrs;
	int CAgentPtr_CGhostImage_List_field650;
	int field654;
	int field658;
	int field65C;
	int field660;
	int field664;

	void on_mouse_down(CMouseEvent* event);
};
