#include "wc3/agile_data.hpp"

#include "wc3/game_base.hpp"

bool AGILE_DATA::is_subtype(uint32_t type_a, uint32_t type_b) {
	if (type_a == type_b) {
		return true;
	}

	auto it = type_data_table.find(type_a);
	if (it != type_data_table.end()) {
		AGILE_TYPE_DATA& data = *(*it).second;

		if (data.parent_type_id == type_b) {
			return true;
		}

		auto relation_it = data.relationships.find(type_b);
		if (relation_it != data.relationships.end()) {
			return (*relation_it).second->is_super;
		}
		else {
			// TODO: cache result
			return is_subtype(data.parent_type_id, type_b);
		}
	}

	return false;
}

static uintptr_t agile_data_offset = get_offset("AGILE_DATA::instance", {
	{GameVersion::v1_26a, 0xAB7368},
	{GameVersion::v1_27a, 0xBB82BC},
});

AGILE_DATA** pp_agile_data = (AGILE_DATA**)(get_game_base() + agile_data_offset);

AGILE_DATA* AGILE_DATA::instance() {
	return *pp_agile_data;
}
