#include "wc3/game_state.hpp"

#include "wc3/game_base.hpp"

void CGameState::increment_handle_references(AgentHandle handle) {
	++handles[handle_to_index(handle)].references;
}

void CGameState::decrement_handle_references(AgentHandle handle) {
	if (--handles[handle_to_index(handle)].references == 0) {
		release_handle(handle);
	}
}

void CGameState::release_handle(AgentHandle handle) {
	_CGameState_ReleaseHandle(this, handle);
}

static uintptr_t CGameState_GetAgentHandle_offset = get_offset(
	"CGameState::GetAgentHandle",
	{
		{GameVersion::v1_26a, 0x430C80},
		{GameVersion::v1_27a, 0x2651D0},
	}
);
TCGameState_GetAgentHandle _CGameState_GetAgentHandle = (TCGameState_GetAgentHandle)(get_game_base() + CGameState_GetAgentHandle_offset);


static uintptr_t CGameState_DecrementHandleReferences_offset = get_offset(
	"CGameState::DecrementHandleReferences",
	{
		{GameVersion::v1_26a, 0x42DD40},
		{GameVersion::v1_27a, 0x2662E0},
	}
);
TCGameState_DecrementHandleReferences _CGameState_DecrementHandleReferences = (TCGameState_DecrementHandleReferences)(get_game_base() + CGameState_DecrementHandleReferences_offset);

static uintptr_t CGameState_ReleaseHandle_offset = get_offset(
	"CGameState::ReleaseHandle",
	{
		{GameVersion::v1_26a, 0x42D3F0},
		{GameVersion::v1_27a, 0x26C6A0},
	}
);
TCGameState_ReleaseHandle _CGameState_ReleaseHandle = (TCGameState_ReleaseHandle)(get_game_base() + CGameState_ReleaseHandle_offset);

int handle_to_index(AgentHandle handle) {
	return handle - FIRST_JASS_HANDLE;
}
