#include "wc3/game_ui.hpp"

#include "wc3/game_base.hpp"

void CInventoryBar::update() {
	static_cast<CInventoryBar::_VMT*>(_vtable)->update(this);
}

void CWorldFrameWar3::on_mouse_down(CMouseEvent* event) {
	static_cast<CWorldFrameWar3::_VMT*>(this->CLayer::_vtable)->on_mouse_down(this, event);
}

void CGameUI::close_current_input_mode() {
	_CGameUI_CloseCurrentInputMode(this);
}

CGameUI* CGameUI::instance() {
	return *p_global_with_game_ui_instance;
}

static uintptr_t CSelectMode_VMT_offset = get_offset(
	"CSelectMode::VMT",
	{
		{GameVersion::v1_26a, 0x9409A8},
		{GameVersion::v1_27a, 0x98E0EC},
	}
);
CSelectMode::_VMT* CSelectMode::VMT = (CSelectMode::_VMT*)(get_game_base() + CSelectMode_VMT_offset);

static uintptr_t _CSelectMode_push_command_offset = get_offset(
	"CSelectMode::push_command",
	{
		{GameVersion::v1_26a, 0x37C420},
		{GameVersion::v1_27a, 0x3752C0},
	}
);
push_command_func_t _CSelectMode_push_command = (push_command_func_t)(get_game_base() + _CSelectMode_push_command_offset);

BOOL CSelectMode::push_command(int ability_id, int order_id, int order_flags, CItem* used_item, CItem* dragged_item, BOOL subgroup_order) {
	return _CSelectMode_push_command(this, ability_id, order_id, order_flags, used_item, dragged_item, subgroup_order);
}

static uintptr_t CGameUI_CloseCurrentInputMode_offset = get_offset(
	"CGameUI::CloseCurrentInputMode",
	{
		{GameVersion::v1_26a, 0x2FB920},
		{GameVersion::v1_27a, 0x356E50},
	}
);
TCGameUI_CloseCurrentInputMode _CGameUI_CloseCurrentInputMode = (TCGameUI_CloseCurrentInputMode)(get_game_base() + CGameUI_CloseCurrentInputMode_offset);

static uintptr_t _CGameUI_SetInputMode_offset = get_offset(
	"CGameUI::SetInputMode",
	{
		{GameVersion::v1_26a, 0x2FB7E0},
		{GameVersion::v1_27a, 0x356AC0},
	}
);
TCGameUI_SetInputMode _CGameUI_SetInputMode = (TCGameUI_SetInputMode)(get_game_base() + _CGameUI_SetInputMode_offset);

void CGameUI::set_input_mode(CInputMode& mode) {
	_CGameUI_SetInputMode(this, &mode, true);
}

static uintptr_t CGameUI_Instance_offset = get_offset(
	"CGameUI::Instance",
	{
		{GameVersion::v1_26a, 0xAB4F80},
		{GameVersion::v1_27a, 0xBE6350},
	}
);
CGameUI** p_global_with_game_ui_instance = (CGameUI**)(get_game_base() + CGameUI_Instance_offset);
