#include "wc3/hashtable.hpp"

static uint32_t hash32_table[] {
	0x98AA3D0C, 0xF67BCA9E, 0xC46CA84C, 0x2AC9D845,
	0x9A1CF1DD, 0x6450148E, 0x8516213D, 0xC0882BBF,
	0xF10C2A9C, 0x9D7CF013, 0xCD845F5E, 0x1D4BD837,
	0x1055F69A, 0xA6A87DCD, 0x312D8D9E, 0x645A1CEC,
};

uint32_t hash32(uint32_t value) {
	uint32_t result = 0x7FED7FED;
	uint32_t i = 0xEEEEEEEE;
	while (value) {
		result = (hash32_table[(uint8_t)value >> 4] - hash32_table[value & 0xF]) ^ (i + result);
		i = (i + (uint8_t)value + 32 * i) + result + 3;
		value >>= 8;
	}
	return result;
}
