#include "wc3/input_events.hpp"

#include <winuser.h>
#include "wc3/game_base.hpp"

static uintptr_t p_evt_context_table_offset = get_offset(
	"p_evt_context_table",
	{
		{GameVersion::v1_26a, 0xACEA68},
		{GameVersion::v1_27a, 0xBB8800},
	}
);
EvtContextTable* p_evt_context_table = (EvtContextTable*)(get_game_base() + p_evt_context_table_offset);

static uintptr_t emit_event_offset = get_offset(
	"emit_event",
	{
		{GameVersion::v1_26a, 0x632460},
		{GameVersion::v1_27a, 0x05AE90},
	}
);
emit_event_t emit_event = (emit_event_t)(get_game_base() + emit_event_offset);

static uintptr_t register_event_handler_offset = get_offset(
	"register_event_handler",
	{
		{GameVersion::v1_26a, 0x62B390},
		{GameVersion::v1_27a, 0x057A90},
	}
);
register_event_handler_t register_event_handler = (register_event_handler_t)(get_game_base() + register_event_handler_offset);

static uintptr_t unregister_event_handler_offset = get_offset(
	"unregister_event_handler",
	{
		{GameVersion::v1_26a, 0x62BA90},
		{GameVersion::v1_27a, 0x058050},
	}
);
unregister_event_handler_t unregister_event_handler = (unregister_event_handler_t)(get_game_base() + unregister_event_handler_offset);

static uintptr_t get_mouse_position_offset = get_offset("", {
	{GameVersion::v1_26a, 0x6312A0},
	{GameVersion::v1_27a, 0x059A90},
});
TGetMousePosition get_mouse_position = (TGetMousePosition)(get_game_base() + get_mouse_position_offset);

static uintptr_t game_window_offset = get_offset(
	"game_window",
	{
		{GameVersion::v1_26a, 0xAD1398},
		{GameVersion::v1_27a, 0xBDA9CC},
	}
);
HWND* p_game_window = (HWND*)(get_game_base() + game_window_offset);

Vector2f get_mouse_position_percents() {
	POINT point;
	RECT rect;
	Vector2f result = {0, 0};

	if (GetCursorPos(&point)
		&& ScreenToClient(*p_game_window, &point)
		&& GetClientRect(*p_game_window, &rect)
	) {
		result.x = (float)point.x / (rect.right - rect.left);
		result.y = 1.0f - ((float)point.y / (rect.bottom - rect.top));
	}

	return result;
}
