#include "wc3/multiboard.hpp"

#include "wc3/game_base.hpp"

void CMultiboard::set_minimized(bool state) {
	if (minimized != state) {
		if (state) {
			CMultiboard_Minimize(this);
		}
		else {
			CMultiboard_Maximize(this);
		}

		if (multiboard_war3->is_valid()) {
			multiboard_war3->minimized = state;
		}

		minimized = state;
	}
}

static uintptr_t CMultiboard_Minimize_offset = get_offset(
	"CMultiboard::Minimize",
	{
		{GameVersion::v1_26a, 0x389720},
		{GameVersion::v1_27a, 0x3C10B0},
	}
);
TCMultiboard_Minimize CMultiboard_Minimize = (TCMultiboard_Minimize)(get_game_base() + CMultiboard_Minimize_offset);

static uintptr_t CMultiboard_Maximize_offset = get_offset(
	"CMultiboard::Maximize",
	{
		{GameVersion::v1_26a, 0x389800},
		{GameVersion::v1_27a, 0x3C0FB0},
	}
);
TCMultiboard_Maximize CMultiboard_Maximize = (TCMultiboard_Maximize)(get_game_base() + CMultiboard_Maximize_offset);
