#include "wc3/net_commands.hpp"

CDataStore& operator << (CDataStore& store, const CNetCommandUnitOrderBasic& command) {
	return store << command.flags << command.order_id << command.item_tag;
}

CDataStore& operator << (CDataStore& store, const CNetCommandUnitOrderTargetPoint& command) {
	return store << static_cast<CNetCommandUnitOrderBasic>(command) << command.x << command.y;
}

CDataStore& operator << (CDataStore& store, const CNetCommandUnitOrderTargetImage& command) {
	return store << static_cast<CNetCommandUnitOrderTargetPoint>(command) << command.target_tag;
}

CDataStore& operator << (CDataStore& store, const CNetCommandUnitOrderTargetImage2& command) {
	return store << static_cast<CNetCommandUnitOrderTargetImage>(command) << command.target_item_tag;
}

CDataStore& operator << (CDataStore& store, const CNetCommandUnitOrderTargetImageFogged& command) {
	return store << static_cast<CNetCommandUnitOrderTargetPoint>(command)
		<< command.target_type_id
		<< command.flags2
		<< command.unk
		<< command.target_owner_id
		<< command.fogged_target_x
		<< command.fogged_target_y;
}

CDataStore& operator << (CDataStore& store, const CNetCommandUnitOrderTargetImageFogged2& command) {
	return store << static_cast<CNetCommandUnitOrderTargetImageFogged>(command) << command.fogged_item_tag;
}
