#include "wc3/tempest_thread.hpp"

#include "wc3/game_base.hpp"

CPresenceTagged* tempest_thread::get_container(const NetTag& tag) {
	int table_index = (tag.presence & 0x80000000) != 0;
	int item_index = tag.presence & 0x7FFFFFFF;
	auto& table = dyntables[table_index];

	if (item_index < table.size) {
		auto& item = table.p_extra_memory[item_index];
		if (item.field00 == -2) {
			CPresenceTagged* container = reinterpret_cast<CPresenceTagged*>(item.memory);
			if (container->self_tag.birth == tag.birth) {
				return container;
			}
		}
	}

	return nullptr;
}

uint32_t tempest_thread_instance_offset = get_offset("tempest_thread_instance_offset", {
	{GameVersion::v1_26a, 0xAB7788},
	{GameVersion::v1_27a, 0xBE40A8},
});

tempest_thread** pp_tempest_thread = (tempest_thread**)(get_game_base() + tempest_thread_instance_offset);

tempest_thread* tempest_thread::instance() {
	return *pp_tempest_thread;
}
