#include "wc3/wc3props.hpp"

#include "processthreadsapi.h"
#include "wc3/game_base.hpp"


static uintptr_t gvar_wc3_props_tls_offset = get_offset(
	"wc3_props_tls_index",
	{
		{GameVersion::v1_26a, 0xAB7BF4},
		{GameVersion::v1_27a, 0xBB8628},
	}
);
DWORD* gvar_wc3_props_tls = (DWORD*)(get_game_base() + gvar_wc3_props_tls_offset);

static uintptr_t wc3_props_offset = get_offset(
	"wc3_props_offset",
	{
		{GameVersion::v1_26a, 0xADA848},
		{GameVersion::v1_27a, 0xBE3740},
	}
);
TWc3Props** gvar_wc3_props = (TWc3Props**)(get_game_base() + wc3_props_offset);

void* get_wc3_prop(Wc3PropSlot slot) {
	TWc3Props* props = (TWc3Props*)TlsGetValue(*gvar_wc3_props_tls);
	if (props) {
		return (*props)[static_cast<int>(slot)];
	}

	return nullptr;
}
